package com.sm9i.aliyun_video.aliyun.mixrecorder;

import android.content.Context;
import android.util.Log;
import android.view.Gravity;
import android.view.SurfaceView;
import android.widget.FrameLayout;

import com.aliyun.mix.AliyunMixMediaInfoParam;
import com.aliyun.recorder.AliyunRecorderCreator;
import com.aliyun.recorder.supply.AliyunIClipManager;
import com.aliyun.recorder.supply.AliyunIRecorder;
import com.aliyun.recorder.supply.RecordCallback;
import com.aliyun.svideo.sdk.external.struct.common.VideoQuality;
import com.aliyun.svideo.sdk.external.struct.effect.EffectBean;
import com.aliyun.svideo.sdk.external.struct.effect.EffectFilter;
import com.aliyun.svideo.sdk.external.struct.effect.EffectPaster;
import com.aliyun.svideo.sdk.external.struct.recorder.CameraType;
import com.aliyun.svideo.sdk.external.struct.recorder.FlashType;
import com.aliyun.svideo.sdk.external.struct.recorder.MediaInfo;
import com.aliyun.svideo.sdk.external.struct.snap.AliyunSnapVideoParam;
import com.qu.preview.callback.OnFrameCallBack;
import com.qu.preview.callback.OnTextureIdCallBack;
import com.sm9i.aliyun_video.R;
import com.sm9i.aliyun_video.aliyun.common.utils.ScreenUtils;

/**
 * 包含录制功能
 */
public class AlivcRecorder implements AlivcIMixRecorderInterface {


    private Context mContext;
    private AliyunIRecorder mRecorder;
    //视频分辨率
    private int mResolutionMode = AliyunSnapVideoParam.RESOLUTION_540P;
    //视频比例
    private int mRatioMode = AliyunSnapVideoParam.RATIO_MODE_3_4;

    public AlivcRecorder(Context mContext) {
        this.mContext = mContext;
        initRecorder();
    }


    /**
     * 初始化recorder
     */
    private void initRecorder() {
        mRecorder = AliyunRecorderCreator.getRecorderInstance(mContext);

    }

    @Override
    public void setMediaInfo(AliyunMixMediaInfoParam mixInputInfo, MediaInfo outputInfo) {
        mRecorder.setMediaInfo(outputInfo);
    }

    @Override
    public AliyunIClipManager getClipManager() {
        return mRecorder.getClipManager();
    }

    @Override
    public void setOutputPath(String var1) {
        mRecorder.setOutputPath(var1);
    }

    @Override
    public void setVideoQuality(VideoQuality var1) {
        mRecorder.setVideoQuality(var1);
    }

    @Override
    public void setGop(int var1) {
        mRecorder.setGop(var1);
    }

    @Override
    public void setCamera(CameraType var1) {
        mRecorder.setCamera(var1);
    }

    @Override
    public int getCameraCount() {
        return mRecorder.getCameraCount();
    }

    @Override
    public void setDisplayView(SurfaceView cameraPreviewView, SurfaceView playerView) {
        mRecorder.setDisplayView(cameraPreviewView);
    }

    @Override
    public void startPreview() {
        mRecorder.startPreview();
    }

    @Override
    public void stopPreview() {
        mRecorder.stopPreview();

    }

    @Override
    public void addPaster(EffectPaster var1) {
        mRecorder.addPaster(var1);
    }

    @Override
    public void addPaster(EffectPaster var1, float var2, float var3, float var4, float var5, float var6, boolean var7) {
        mRecorder.addPaster(var1, var2, var3, var4, var5, var6, var7);
    }

    @Override
    public void removePaster(EffectPaster var1) {
        mRecorder.removePaster(var1);
    }

    @Override
    public void applyFilter(EffectFilter var1) {
        mRecorder.applyFilter(var1);
    }

    @Override
    public void setMusic(String var1, long var2, long var4) {
        mRecorder.setMusic(var1, var2, var4);
    }

    @Override
    public int switchCamera() {
        return mRecorder.switchCamera();
    }

    @Override
    public void setLight(FlashType var1) {
        mRecorder.setLight(var1);
    }

    @Override
    public void setZoom(float var1) {
        mRecorder.setZoom(var1);
    }

    @Override
    public void setFocusMode(int var1) {
        mRecorder.setFocusMode(var1);
    }

    @Override
    public void setRate(float var1) {
        mRecorder.setRate(var1);
    }

    @Override
    public void setFocus(float var1, float var2) {
        mRecorder.setFocus(var1, var2);
    }


    @Override
    public void setBeautyLevel(int var1) {
        mRecorder.setBeautyLevel(var1);
    }

    @Override
    public void setBeautyStatus(boolean var1) {
        mRecorder.setBeautyStatus(var1);
    }

    @Override
    public void startRecording() {
        mRecorder.startRecording();
    }

    @Override
    public void stopRecording() {
        mRecorder.stopRecording();
    }

    @Override
    public int finishRecording() {
        return mRecorder.finishRecording();
    }

    @Override
    public void setRecordCallback(RecordCallback var1) {
        mRecorder.setRecordCallback(var1);
    }

    @Override
    public void setOnFrameCallback(OnFrameCallBack var1) {
        mRecorder.setOnFrameCallback(var1);
    }

    @Override
    public void setRotation(int var1) {
        mRecorder.setRotation(var1);
    }

    @Override
    public void setOnTextureIdCallback(OnTextureIdCallBack var1) {
        mRecorder.setOnTextureIdCallback(var1);
    }

    @Override
    public void needFaceTrackInternal(boolean var1) {
        mRecorder.needFaceTrackInternal(var1);
    }

    @Override
    public void setFaceTrackInternalModelPath(String var1) {
        mRecorder.setFaceTrackInternalModelPath(var1);
    }

    @Override
    public void setFaceTrackInternalMaxFaceCount(int var1) {
        mRecorder.setFaceTrackInternalMaxFaceCount(var1);
    }

    @Override
    public void setMute(boolean var1) {
        mRecorder.setMute(var1);
    }

    @Override
    public void deleteLastPart() {
        mRecorder.getClipManager().deletePart();
    }

    @Override
    public void restartMv() {
        mRecorder.restartMv();
    }

    @Override
    public void applyMv(EffectBean var1) {
        mRecorder.applyMv(var1);
    }

    @Override
    public void setResolutionMode(int resolutionMode) {
        mResolutionMode = resolutionMode;
    }

    @Override
    public void setRatioMode(int ratioMode) {
        mRatioMode = ratioMode;

    }

    @Override
    public boolean isMixRecorder() {
        return false;
    }

    @Override
    public void release() {
        mRecorder.destroy();
    }

    @Override
    public void takePicture(boolean needBitmap) {
        mRecorder.takePicture(needBitmap);
    }

    /**
     * 设置界面比例
     */
    @Override
    public FrameLayout.LayoutParams getLayoutParams() {

        int screenWidth = ScreenUtils.getRealWidth(mContext);
        int height = 0;
        int top = 0;
        FrameLayout.LayoutParams params = new FrameLayout.LayoutParams(screenWidth, height);

        switch (mRatioMode) {
            case AliyunSnapVideoParam.RATIO_MODE_1_1:
                //视频比例为1：1的时候，录制界面向下移动，移动位置为顶部菜单栏的高度
                top = mContext.getResources().getDimensionPixelSize(R.dimen.alivc_record_title_height);
                params.setMargins(0, top, 0, 0);
                height = screenWidth;
                break;
            case AliyunSnapVideoParam.RATIO_MODE_3_4:
                //视频比例为3：4的时候，录制界面向下移动，移动位置为顶部菜单栏的高度
                top = mContext.getResources().getDimensionPixelSize(R.dimen.alivc_record_title_height);
                params.setMargins(0, top, 0, 0);
                height = screenWidth * 4 / 3;
                break;
            case AliyunSnapVideoParam.RATIO_MODE_9_16:

                int screenHeight = ScreenUtils.getRealHeight(mContext);
                float screenRatio = screenWidth / (float) screenHeight;
                if (screenRatio >= 9 / 16f) {
                    //胖手机宽高比小于9/16
                    params.width = screenWidth;
                    height = screenWidth * 16 / 9;
                } else {
                    height = screenHeight;
                    params.width = screenHeight * 9 / 16;
                }
                Log.e("RealHeight", "height:" + screenHeight + "width:" + screenWidth);
                params.gravity = Gravity.CENTER;
                break;
            default:
                height = screenWidth * 16 / 9;
                break;
        }
        params.height = height;
        mRecorder.resizePreviewSize(params.width, params.height);
        return params;
    }

    @Override
    public void setMixRecorderRatio(SurfaceView surfaceView) {

    }

    @Override
    public void setMixPlayerRatio(SurfaceView surfaceView) {

    }

    /**
     * 获取拍摄视频宽度
     *
     * @return
     */
    @Override
    public int getVideoWidth() {
        int width = 0;
        switch (mResolutionMode) {
            case AliyunSnapVideoParam.RESOLUTION_360P:
                width = 360;
                break;
            case AliyunSnapVideoParam.RESOLUTION_480P:
                width = 480;
                break;
            case AliyunSnapVideoParam.RESOLUTION_540P:
                width = 540;
                break;
            case AliyunSnapVideoParam.RESOLUTION_720P:
                width = 720;
                break;
            default:
                width = 540;
                break;
        }

        return width;
    }

    @Override
    public int getVideoHeight() {
        int width = getVideoWidth();
        int height = 0;
        switch (mRatioMode) {
            case AliyunSnapVideoParam.RATIO_MODE_1_1:
                height = width;
                break;
            case AliyunSnapVideoParam.RATIO_MODE_3_4:
                height = width * 4 / 3;
                break;
            case AliyunSnapVideoParam.RATIO_MODE_9_16:
                height = width * 16 / 9;
                break;
            default:
                height = width;
                break;
        }
        return height;
    }


}
